Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Canon.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Canon.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Canon.pm	(revision 34921)
@@ -4882,5 +6286,102 @@
         # usually, but not always, the lowest number AF point in focus
         Name => 'PrimaryAFPoint',
-        Condition => '$$self{Model} !~ /EOS/',
+        Condition => '$$self{Model} !~ /EOS/ and not $$self{AFInfo3}', # (not valid for G1XmkII)
+    },
+);
+
+# contrast information (MakerNotes tag 0x27) - PH
+%Image::ExifTool::Canon::ContrastInfo = (
+    %binaryDataAttrs,
+    FORMAT => 'int16u',
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    4 => {
+        Name => 'IntelligentContrast',
+        PrintHex => 1,
+        PrintConv => {
+            0x00 => 'Off',
+            0x08 => 'On',
+            0xffff => 'n/a',
+            OTHER => sub {
+                # DPP shows "On" for any value except 0xffff when bit 0x08 is set
+                my ($val, $inv) = @_;
+                if ($inv) {
+                    $val =~ /(0x[0-9a-f]+)/i or $val =~ /(\d+)/ or return undef;
+                    return $1;
+                } else {
+                    return sprintf("On (0x%.2x)",$val) if $val & 0x08;
+                    return sprintf("Off (0x%.2x)",$val);
+                }
+            },
+        },
+    },
+    # 6 - 0=normal, 257=i-Contrast On
+);
+
+# time information (MakerNotes tag 0x35) - PH (1DX, 5DmkIII)
+%Image::ExifTool::Canon::TimeInfo = (
+    %binaryDataAttrs,
+    FORMAT => 'int32s',
+    FIRST_ENTRY => 1,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Time' },
+    # 0 - size (16 bytes)
+    1 => {
+        Name => 'TimeZone',
+        PrintConv => 'Image::ExifTool::TimeZoneString($val)',
+        PrintConvInv => sub {
+            my $val = shift;
+            $val =~ /^([-+]?)(\d{1,2}):?(\d{2})$/ or return undef;
+            return(($1 eq '-' ? -1 : 1) * ($2 * 60 + $3));
+        },
+    },
+    2 => {
+        Name => 'TimeZoneCity',
+        PrintConvColumns => 3,
+        PrintConv => {
+            # [square brackets] = actual time zone for each city
+            # (round brackets) = observed time zone values from sample images
+            # --> unobserved entries have not been confirmed!
+            0 => 'n/a', # (PowerShot models)
+            1 => 'Chatham Islands', # [+12:45]
+            2 => 'Wellington',      # [+12] (+12:00,DST+0)
+            3 => 'Solomon Islands', # [+11]
+            4 => 'Sydney',          # [+10] (+11:00,DST+1)
+            5 => 'Adelaide',        # [+9:30]
+            6 => 'Tokyo',           # [+9] (+09:00,DST+0)
+            7 => 'Hong Kong',       # [+8] (+08:00,DST+0)
+            8 => 'Bangkok',         # [+7] (+08:00,DST+1)
+            9 => 'Yangon',          # [+6:30]
+            10 => 'Dhaka',          # [+6] (Canon uses old "Dacca" spelling)
+            11 => 'Kathmandu',      # [+5:45]
+            12 => 'Delhi',          # [+5:30]
+            13 => 'Karachi',        # [+5]
+            14 => 'Kabul',          # [+4:30]
+            15 => 'Dubai',          # [+4]
+            16 => 'Tehran',         # [+3:30]
+            17 => 'Moscow',         # [+4] (+03:00,DST+0) (! changed to +4 permanent DST in 2011)
+            18 => 'Cairo',          # [+2]
+            19 => 'Paris',          # [+1] (+01:10,DST+0; +02:00,DST+1)
+            20 => 'London',         # [0]  (+00:00,DST+0)
+            21 => 'Azores',         # [-1]
+            22 => 'Fernando de Noronha', # [-2]
+            23 => 'Sao Paulo',      # [-3]
+            24 => 'Newfoundland',   # [-3:30]
+            25 => 'Santiago',       # [-4]
+            26 => 'Caracas',        # [-4:30]
+            27 => 'New York',       # [-5] (-05:00,DST+0; -04:00,DST+1)
+            28 => 'Chicago',        # [-6]
+            29 => 'Denver',         # [-7]
+            30 => 'Los Angeles',    # [-8] (-08:00,DST+0; -07:00,DST+1)
+            31 => 'Anchorage',      # [-9]
+            32 => 'Honolulu',       # [-10]
+            33 => 'Samoa',          # [+13]
+            32766 => '(not set)',   #(NC)
+        },
+    },
+    3 => {
+        Name => 'DaylightSavings',
+        PrintConv => {
+            0 => 'Off',
+            60 => 'On',
+        },
     },
 );
@@ -4992,4 +6493,36 @@
 );
 
+# G9 white balance information (MakerNotes tag 0x29) (ref IB)
+%Image::ExifTool::Canon::WBInfo = (
+    %binaryDataAttrs,
+    NOTES => 'WB tags for the Canon G9.',
+    FORMAT => 'int32u',
+    FIRST_ENTRY => 1,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Image' },
+    0x02 => { Name => 'WB_GRGBLevelsAuto',        Format => 'int32s[4]' },
+    0x0a => { Name => 'WB_GRGBLevelsDaylight',    Format => 'int32s[4]' },
+    0x12 => { Name => 'WB_GRGBLevelsCloudy',      Format => 'int32s[4]' },
+    0x1a => { Name => 'WB_GRGBLevelsTungsten',    Format => 'int32s[4]' },
+    0x22 => { Name => 'WB_GRGBLevelsFluorescent', Format => 'int32s[4]' },
+    0x2a => { Name => 'WB_GRGBLevelsFluorHigh',   Format => 'int32s[4]' },
+    0x32 => { Name => 'WB_GRGBLevelsFlash',       Format => 'int32s[4]' },
+    0x3a => { Name => 'WB_GRGBLevelsUnderwater',  Format => 'int32s[4]' },
+    0x42 => { Name => 'WB_GRGBLevelsCustom1',     Format => 'int32s[4]' },
+    0x4a => { Name => 'WB_GRGBLevelsCustom2',     Format => 'int32s[4]' },
+);
+
+# yet more face detect information (MakerNotes tag 0x2f) - PH (G12)
+%Image::ExifTool::Canon::FaceDetect3 = (
+    %binaryDataAttrs,
+    FORMAT => 'int16u',
+    FIRST_ENTRY => 1,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Image' },
+    # 0 - size (34 bytes)
+    # 1 - 1=4:3/16:9,2=1:1/3:2/4:5
+    # 2 - normally 1 if faces detected, but sometimes 0 (maybe if face wasn't in captured image?)
+    3 => 'FacesDetected',
+    # 4 - 240=4:3/4:5/1:1,180=16:9,212=3:2
+);
+
 # File number information (MakerNotes tag 0x93)
 %Image::ExifTool::Canon::FileInfo = (
@@ -4998,4 +6531,5 @@
     FIRST_ENTRY => 1,
     GROUPS => { 0 => 'MakerNotes', 2 => 'Image' },
+    DATAMEMBER => [ 20 ],
     1 => [
         { #5
@@ -5065,4 +6599,9 @@
         { #7 (1DmkII, 1DSmkII, 1DSmkIIN)
             Name => 'ShutterCount',
+            # ref http://www.luminous-landscape.com/forum/index.php?topic=36469 :
+            Notes => q{
+                there are reports that the ShutterCount changed when loading a settings file
+                on the 1DSmkII
+            },
             Condition => '$$self{Model} =~ /\b1Ds? Mark II\b/',
             Format => 'int32u',
@@ -5163,5 +6702,24 @@
         # http://www.breezesys.com/forum/showthread.php?p=16980)
         Name => 'LiveViewShooting',
-        PrintConv => { 0 => 'Off', 1 => 'On' },
+        PrintConv => \%offOn,
+    },
+    20 => { #47
+        Name => 'FocusDistanceUpper',
+        DataMember => 'FocusDistanceUpper2',
+        Format => 'int16u',
+        RawConv => '($$self{FocusDistanceUpper2} = $val) || undef',
+        ValueConv => '$val / 100',
+        ValueConvInv => '$val * 100',
+        PrintConv => '$val > 655.345 ? "inf" : "$val m"',
+        PrintConvInv => '$val =~ s/ ?m$//; IsFloat($val) ? $val : 655.35',
+    },
+    21 => { #47
+        Name => 'FocusDistanceLower',
+        Condition => '$$self{FocusDistanceUpper2}',
+        Format => 'int16u',
+        ValueConv => '$val / 100',
+        ValueConvInv => '$val * 100',
+        PrintConv => '$val > 655.345 ? "inf" : "$val m"',
+        PrintConvInv => '$val =~ s/ ?m$//; IsFloat($val) ? $val : 655.35',
     },
     # 22 - values: 0, 1
@@ -5169,5 +6727,34 @@
     25 => { #PH
         Name => 'FlashExposureLock',
-        PrintConv => { 0 => 'Off', 1 => 'On' },
+        PrintConv => \%offOn,
+    },
+    0x3d => { #IB
+        Name => 'RFLensType',
+        Format => 'int16u',
+        PrintConv => {
+            0 => 'n/a',
+            257 => 'Canon RF 50mm F1.2L USM',
+            258 => 'Canon RF 24-105mm F4L IS USM',
+            259 => 'Canon RF 28-70mm F2L USM',
+            260 => 'Canon RF 35mm F1.8 MACRO IS STM',
+            261 => 'Canon RF 85mm F1.2L USM',
+            262 => 'Canon RF 85mm F1.2L USM DS',
+            263 => 'Canon RF 24-70mm F2.8L IS USM',
+            264 => 'Canon RF 15-35mm F2.8L IS USM',
+            265 => 'Canon RF 24-240mm F4-6.3 IS USM',
+            266 => 'Canon RF 70-200mm F2.8L IS USM',
+            267 => 'Canon RF 85mm F2 MACRO IS STM',
+            268 => 'Canon RF 600mm F11 IS STM',
+            269 => 'Canon RF 600mm F11 IS STM + RF1.4x',
+            270 => 'Canon RF 600mm F11 IS STM + RF2x',
+            271 => 'Canon RF 800mm F11 IS STM',
+            272 => 'Canon RF 800mm F11 IS STM + RF1.4x',
+            273 => 'Canon RF 800mm F11 IS STM + RF2x',
+            274 => 'Canon RF 24-105mm F4-7.1 IS STM',
+            275 => 'Canon RF 100-500mm F4.5-7.1L IS USM',
+            276 => 'Canon RF 100-500mm F4.5-7.1L IS USM + RF1.4x',
+            277 => 'Canon RF 100-500mm F4.5-7.1L IS USM + RF2x',
+            # Note: add new RF lenses to %canonLensTypes with ID 61182
+        },
     },
 );
@@ -5210,8 +6797,13 @@
             7 => '16:9',
             8 => '4:5',
-        },
-    },
-    1 => 'CroppedImageWidth', # (could use a better name for these)
+            12 => '3:2 (APS-H crop)', #IB
+            13 => '3:2 (APS-C crop)', #IB
+        },
+    },
+    # (could use better names for these, or the Crop tags above, or both)
+    1 => 'CroppedImageWidth',
     2 => 'CroppedImageHeight',
+    3 => 'CroppedImageLeft', #forum4138
+    4 => 'CroppedImageTop', #ditto
 );
 
@@ -5287,13 +6879,22 @@
     GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
     # red,green1,green2,blue (ref 2)
-    0  => { Name => 'WB_RGGBLevelsAuto',       Format => 'int16s[4]' },
-    4  => { Name => 'WB_RGGBLevelsDaylight',   Format => 'int16s[4]' },
-    8  => { Name => 'WB_RGGBLevelsShade',      Format => 'int16s[4]' },
-    12 => { Name => 'WB_RGGBLevelsCloudy',     Format => 'int16s[4]' },
-    16 => { Name => 'WB_RGGBLevelsTungsten',   Format => 'int16s[4]' },
-    20 => { Name => 'WB_RGGBLevelsFluorescent',Format => 'int16s[4]' },
-    24 => { Name => 'WB_RGGBLevelsFlash',      Format => 'int16s[4]' },
-    28 => { Name => 'WB_RGGBLevelsCustom',     Format => 'int16s[4]' },
-    32 => { Name => 'WB_RGGBLevelsKelvin',     Format => 'int16s[4]' },
+    1  => { Name => 'WB_RGGBLevelsAuto',       Format => 'int16s[4]' },
+    5  => { Name => 'WB_RGGBLevelsDaylight',   Format => 'int16s[4]' },
+    9  => { Name => 'WB_RGGBLevelsShade',      Format => 'int16s[4]' },
+    13 => { Name => 'WB_RGGBLevelsCloudy',     Format => 'int16s[4]' },
+    17 => { Name => 'WB_RGGBLevelsTungsten',   Format => 'int16s[4]' },
+    21 => { Name => 'WB_RGGBLevelsFluorescent',Format => 'int16s[4]' },
+    25 => { Name => 'WB_RGGBLevelsFlash',      Format => 'int16s[4]' },
+    29 => [{
+        Name => 'WB_RGGBLevelsCustom',
+        Notes => 'black levels for the D60',
+        Condition => '$$self{Model} !~ /EOS D60\b/',
+        Format => 'int16s[4]',
+    },{ # (black levels for D60, ref IB)
+        Name => 'BlackLevels',
+        Format => 'int16s[4]',
+    }],
+    33 => { Name => 'WB_RGGBLevelsKelvin',     Format => 'int16s[4]' },
+    37 => { Name => 'WB_RGGBBlackLevels',      Format => 'int16s[4]' }, #IB
 );
 
@@ -5395,4 +6996,5 @@
         OffsetPair => 5,   # point to associated offset
         DataTag => 'PreviewImage',
+        WriteGroup => 'MakerNotes',
         Protected => 2,
     },
@@ -5404,4 +7006,5 @@
         OffsetPair => 2,  # associated byte count tagID
         DataTag => 'PreviewImage',
+        WriteGroup => 'MakerNotes',
         Protected => 2,
     },
@@ -5611,5 +7214,8 @@
         SubDirectory => { TagTable => 'Image::ExifTool::Canon::ColorCalib' }
     },
-    # 0xc5-0xc7: looks like black levels (ref 37)
+    0xc4 => { #IB
+        Name => 'PerChannelBlackLevel',
+        Format => 'int16u[4]',
+    },
     # 0xc8-0x1c7: some sort of color table (ref 37)
     0x248 => { #37
@@ -5651,5 +7257,5 @@
     NOTES => q{
         These tags are used by the 1DmkIII, 1DSmkIII, 1DmkIV, 5DmkII, 7D, 40D, 50D,
-        450D, 500D, 550D, 1000D and 1100D.
+        60D, 450D, 500D, 550D, 1000D and 1100D.
     },
     FORMAT => 'int16s',
@@ -5657,6 +7263,9 @@
     GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
     IS_SUBDIR => [ 0x3f, 0xa8 ],
+    DATAMEMBER => [ 0x00 ],
     0x00 => {
         Name => 'ColorDataVersion',
+        DataMember => 'ColorDataVersion',
+        RawConv => '$$self{ColorDataVersion} = $val',
         PrintConv => {
             2 => '2 (1DmkIII)',
@@ -5666,5 +7275,5 @@
             6 => '6 (50D/5DmkII)',
             7 => '7 (500D/550D/7D/1DmkIV)',
-            9 => '9 (1100D)',
+            9 => '9 (60D/1100D)',
         },
     },
@@ -5683,4 +7292,5 @@
         SubDirectory => { TagTable => 'Image::ExifTool::Canon::ColorCalib' }
     },
+    0x0e7 => { Name => 'AverageBlackLevel',     Format => 'int16u[4]' }, #IB
     0x280 => { #PH
         Name => 'RawMeasuredRGGB',
@@ -5690,4 +7300,66 @@
         ValueConv => \&SwapWords,
         ValueConvInv => \&SwapWords,
+    },
+    0x2b4 => { #IB
+        Name => 'PerChannelBlackLevel',
+        Condition => '$$self{ColorDataVersion} == 4 or $$self{ColorDataVersion} == 5',
+        Format => 'int16u[4]',
+    },
+    0x2b8 => { #IB
+        Name => 'NormalWhiteLevel',
+        Condition => '$$self{ColorDataVersion} == 4 or $$self{ColorDataVersion} == 5',
+        Format => 'int16u',
+        RawConv => '$val || undef',
+    },
+    0x2b9 => { #IB
+        Name => 'SpecularWhiteLevel',
+        Condition => '$$self{ColorDataVersion} == 4 or $$self{ColorDataVersion} == 5',
+        Format => 'int16u',
+    },
+    0x2ba => { #IB
+        Name => 'LinearityUpperMargin',
+        Condition => '$$self{ColorDataVersion} == 4 or $$self{ColorDataVersion} == 5',
+        Format => 'int16u',
+    },
+    0x2cb => { #IB
+        Name => 'PerChannelBlackLevel',
+        Condition => '$$self{ColorDataVersion} == 6 or $$self{ColorDataVersion} == 7',
+        Format => 'int16u[4]',
+    },
+    0x2cf => [{ #IB
+        Name => 'NormalWhiteLevel',
+        Condition => '$$self{ColorDataVersion} == 6 or $$self{ColorDataVersion} == 7',
+        Format => 'int16u',
+        RawConv => '$val || undef',
+    },{
+        Name => 'PerChannelBlackLevel',
+        Condition => '$$self{ColorDataVersion} == 9',
+        Format => 'int16u[4]',
+    }],
+    0x2d0 => { #IB
+        Name => 'SpecularWhiteLevel',
+        Condition => '$$self{ColorDataVersion} == 6 or $$self{ColorDataVersion} == 7',
+        Format => 'int16u',
+    },
+    0x2d1 => { #IB
+        Name => 'LinearityUpperMargin',
+        Condition => '$$self{ColorDataVersion} == 6 or $$self{ColorDataVersion} == 7',
+        Format => 'int16u',
+    },
+    0x2d3 => { #IB
+        Name => 'NormalWhiteLevel',
+        Condition => '$$self{ColorDataVersion} == 9',
+        Format => 'int16u',
+        RawConv => '$val || undef',
+    },
+    0x2d4 => { #IB
+        Name => 'SpecularWhiteLevel',
+        Condition => '$$self{ColorDataVersion} == 9',
+        Format => 'int16u',
+    },
+    0x2d5 => { #IB
+        Name => 'LinearityUpperMargin',
+        Condition => '$$self{ColorDataVersion} == 9',
+        Format => 'int16u',
     },
 );
@@ -5751,4 +7423,58 @@
 );
 
+# color coefficients (ref PH/IB)
+%Image::ExifTool::Canon::ColorCoefs2 = (
+    %binaryDataAttrs,
+    FORMAT => 'int16s',
+    FIRST_ENTRY => 0,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    0x00 => { Name => 'WB_RGGBLevelsAsShot',      Format => 'int16s[4]' },
+    0x07 => 'ColorTempAsShot',
+    0x08 => { Name => 'WB_RGGBLevelsAuto',        Format => 'int16s[4]' },
+    0x0f => 'ColorTempAuto',
+    0x10 => { Name => 'WB_RGGBLevelsMeasured',    Format => 'int16s[4]' },
+    0x17 => 'ColorTempMeasured',
+    0x18 => { Name => 'WB_RGGBLevelsUnknown',     Format => 'int16s[4]', Unknown => 1 },
+    0x1f => { Name => 'ColorTempUnknown', Unknown => 1 },
+    0x20 => { Name => 'WB_RGGBLevelsDaylight',    Format => 'int16s[4]' },
+    0x27 => 'ColorTempDaylight',
+    0x28 => { Name => 'WB_RGGBLevelsShade',       Format => 'int16s[4]' },
+    0x2f => 'ColorTempShade',
+    0x30 => { Name => 'WB_RGGBLevelsCloudy',      Format => 'int16s[4]' },
+    0x37 => 'ColorTempCloudy',
+    0x38 => { Name => 'WB_RGGBLevelsTungsten',    Format => 'int16s[4]' },
+    0x3f => 'ColorTempTungsten',
+    0x40 => { Name => 'WB_RGGBLevelsFluorescent',Format => 'int16s[4]' },
+    0x47 => 'ColorTempFluorescent',
+    0x48 => { Name => 'WB_RGGBLevelsKelvin',     Format => 'int16s[4]' },
+    0x4f => 'ColorTempKelvin',
+    0x50 => { Name => 'WB_RGGBLevelsFlash',      Format => 'int16s[4]' },
+    0x57 => 'ColorTempFlash',
+    0x58 => { Name => 'WB_RGGBLevelsUnknown2',   Format => 'int16s[4]', Unknown => 1 },
+    0x5f => { Name => 'ColorTempUnknown2', Unknown => 1 },
+    0x60 => { Name => 'WB_RGGBLevelsUnknown3',   Format => 'int16s[4]', Unknown => 1 },
+    0x67 => { Name => 'ColorTempUnknown3', Unknown => 1 },
+    0x68 => { Name => 'WB_RGGBLevelsUnknown4',   Format => 'int16s[4]', Unknown => 1 },
+    0x6f => { Name => 'ColorTempUnknown4', Unknown => 1 },
+    0x70 => { Name => 'WB_RGGBLevelsUnknown5',   Format => 'int16s[4]', Unknown => 1 },
+    0x77 => { Name => 'ColorTempUnknown5', Unknown => 1 },
+    0x78 => { Name => 'WB_RGGBLevelsUnknown6',   Format => 'int16s[4]', Unknown => 1 },
+    0x7f => { Name => 'ColorTempUnknown6', Unknown => 1 },
+    0x80 => { Name => 'WB_RGGBLevelsUnknown7',   Format => 'int16s[4]', Unknown => 1 },
+    0x87 => { Name => 'ColorTempUnknown7', Unknown => 1 },
+    0x88 => { Name => 'WB_RGGBLevelsUnknown8',   Format => 'int16s[4]', Unknown => 1 },
+    0x8f => { Name => 'ColorTempUnknown8', Unknown => 1 },
+    0x90 => { Name => 'WB_RGGBLevelsUnknown9',   Format => 'int16s[4]', Unknown => 1 },
+    0x97 => { Name => 'ColorTempUnknown9', Unknown => 1 },
+    0x98 => { Name => 'WB_RGGBLevelsUnknown10',  Format => 'int16s[4]', Unknown => 1 },
+    0x9f => { Name => 'ColorTempUnknown10', Unknown => 1 },
+    0xa0 => { Name => 'WB_RGGBLevelsUnknown11',  Format => 'int16s[4]', Unknown => 1 },
+    0xa7 => { Name => 'ColorTempUnknown11', Unknown => 1 },
+    0xa8 => { Name => 'WB_RGGBLevelsUnknown12',  Format => 'int16s[4]', Unknown => 1 },
+    0xaf => { Name => 'ColorTempUnknown12', Unknown => 1 },
+    0xb0 => { Name => 'WB_RGGBLevelsUnknown13',  Format => 'int16s[4]', Unknown => 1 },
+    0xb7 => { Name => 'ColorTempUnknown13', Unknown => 1 },
+);
+
 # color calibration (ref 37)
 %Image::ExifTool::Canon::ColorCalib = (
@@ -5765,6 +7491,6 @@
     NOTES => q{
         Camera color calibration data.  For the 20D, 350D, 1DmkII and 1DSmkII the
-        order of the cooefficients is A, B, C, Temperature, but for newer models it
-        is B, C, A, Temperature.  These tags are extracted only when the Unknown
+        order of the coefficients is A, B, C, Temperature, but for newer models it
+        is B, C, A, Temperature.  These tags are extracted only when the L<Unknown|../ExifTool.html#Unknown>
         option is used.
     },
@@ -5786,40 +7512,97 @@
 );
 
+# color calibration2
+%Image::ExifTool::Canon::ColorCalib2 = (
+    %binaryDataAttrs,
+    FORMAT => 'int16s',
+    FIRST_ENTRY => 0,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => 'B, C, A, D, Temperature.',
+    0x00 => { Name => 'CameraColorCalibration01', %cameraColorCalibration2 },
+    0x05 => { Name => 'CameraColorCalibration02', %cameraColorCalibration2 },
+    0x0a => { Name => 'CameraColorCalibration03', %cameraColorCalibration2 },
+    0x0f => { Name => 'CameraColorCalibration04', %cameraColorCalibration2 },
+    0x14 => { Name => 'CameraColorCalibration05', %cameraColorCalibration2 },
+    0x19 => { Name => 'CameraColorCalibration06', %cameraColorCalibration2 },
+    0x1e => { Name => 'CameraColorCalibration07', %cameraColorCalibration2 },
+    0x23 => { Name => 'CameraColorCalibration08', %cameraColorCalibration2 },
+    0x28 => { Name => 'CameraColorCalibration09', %cameraColorCalibration2 },
+    0x2d => { Name => 'CameraColorCalibration10', %cameraColorCalibration2 },
+    0x32 => { Name => 'CameraColorCalibration11', %cameraColorCalibration2 },
+    0x37 => { Name => 'CameraColorCalibration12', %cameraColorCalibration2 },
+    0x3c => { Name => 'CameraColorCalibration13', %cameraColorCalibration2 },
+    0x41 => { Name => 'CameraColorCalibration14', %cameraColorCalibration2 },
+    0x46 => { Name => 'CameraColorCalibration15', %cameraColorCalibration2 },
+);
+
 # Color data (MakerNotes tag 0x4001, count=5120) (ref PH)
 %Image::ExifTool::Canon::ColorData5 = (
     %binaryDataAttrs,
-    NOTES => 'These tags are used by the PowerShot G10.',
+    NOTES => 'These tags are used by many EOS M and PowerShot models.',
     FORMAT => 'int16s',
     FIRST_ENTRY => 0,
     GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
-    IS_SUBDIR => [ 0x47 ],
-    # 0x00 - oddly, this isn't ColorDataVersion (probably should have been version 8)
-    0x47 => {
+    DATAMEMBER => [ 0x00 ],
+    IS_SUBDIR => [ 0x47, 0xba, 0xff ],
+    0x00 => {
+        Name => 'ColorDataVersion',
+        DataMember => 'ColorDataVersion',
+        RawConv => '$$self{ColorDataVersion} = $val',
+        PrintConv => {
+            -3 => '-3 (M10/M3)', # (and PowerShot G1X/G1XmkII/G10/G11/G12/G15/G16/G3X/G5X/G7X/G9X/S100/S110/S120/S90/S95/SX1IS/SX50HS/SX60HS)
+            -4 => '-4 (M100/M5/M6)', # (and PowerShot G1XmkIII/G7XmkII/G9XmkII)
+        },
+    },
+    0x47 => [{
         Name => 'ColorCoefs',
+        Condition => '$$self{ColorDataVersion} == -3',
         Format => 'undef[230]', # ColorTempUnknown13 is last entry
         SubDirectory => { TagTable => 'Image::ExifTool::Canon::ColorCoefs' }
-    },
-    0xba => { Name => 'CameraColorCalibration01', %cameraColorCalibration2,
-              Notes => 'B, C, A, D, Temperature' },
-    0xbf => { Name => 'CameraColorCalibration02', %cameraColorCalibration2 },
-    0xc4 => { Name => 'CameraColorCalibration03', %cameraColorCalibration2 },
-    0xc9 => { Name => 'CameraColorCalibration04', %cameraColorCalibration2 },
-    0xce => { Name => 'CameraColorCalibration05', %cameraColorCalibration2 },
-    0xd3 => { Name => 'CameraColorCalibration06', %cameraColorCalibration2 },
-    0xd8 => { Name => 'CameraColorCalibration07', %cameraColorCalibration2 },
-    0xdd => { Name => 'CameraColorCalibration08', %cameraColorCalibration2 },
-    0xe2 => { Name => 'CameraColorCalibration09', %cameraColorCalibration2 },
-    0xe7 => { Name => 'CameraColorCalibration10', %cameraColorCalibration2 },
-    0xec => { Name => 'CameraColorCalibration11', %cameraColorCalibration2 },
-    0xf1 => { Name => 'CameraColorCalibration12', %cameraColorCalibration2 },
-    0xf6 => { Name => 'CameraColorCalibration13', %cameraColorCalibration2 },
-    0xfb => { Name => 'CameraColorCalibration14', %cameraColorCalibration2 },
-    0x100=> { Name => 'CameraColorCalibration15', %cameraColorCalibration2 },
-);
-
-# Color data (MakerNotes tag 0x4001, count=1273) (ref PH)
+    },{
+        Name => 'ColorCoefs2',
+        Condition => '$$self{ColorDataVersion} == -4',
+        Format => 'undef[368]',
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::ColorCoefs2' }
+    }],
+    0xba => {
+        Name => 'ColorCalib2',
+        Condition => '$$self{ColorDataVersion} == -3',
+        Format => 'undef[150]',
+        Unknown => 1,
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::ColorCalib2' }
+    },
+    0xff => {
+        Name => 'ColorCalib2',
+        Condition => '$$self{ColorDataVersion} == -4',
+        Format => 'undef[150]',
+        Unknown => 1,
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::ColorCalib2' }
+    },
+    0x108=> { #IB
+        Name => 'PerChannelBlackLevel',
+        Condition => '$$self{ColorDataVersion} == -3',
+        Format => 'int16s[4]',
+    },
+    0x14d=> { #IB
+        Name => 'PerChannelBlackLevel',
+        Condition => '$$self{ColorDataVersion} == -4',
+        Format => 'int16s[4]',
+    },
+    0x0569 => { #PH (NC)
+        Name => 'NormalWhiteLevel',
+        Condition => '$$self{ColorDataVersion} == -4',
+        Format => 'int16u',
+    },
+    0x056a => { #PH (NC)
+        Name => 'SpecularWhiteLevel',
+        Condition => '$$self{ColorDataVersion} == -4',
+        Format => 'int16u',
+    },
+);
+
+# Color data (MakerNotes tag 0x4001, count=1273|1275) (ref PH)
 %Image::ExifTool::Canon::ColorData6 = (
     %binaryDataAttrs,
-    NOTES => 'These tags are used by the EOS 600D.',
+    NOTES => 'These tags are used by the EOS 600D and 1200D.',
     FORMAT => 'int16s',
     FIRST_ENTRY => 0,
@@ -5829,5 +7612,5 @@
         Name => 'ColorDataVersion',
         PrintConv => {
-            10 => '10 (600D)',
+            10 => '10 (600D/1200D)',
         },
     },
@@ -5889,4 +7672,5 @@
         SubDirectory => { TagTable => 'Image::ExifTool::Canon::ColorCalib' }
     },
+    0x0fb => { Name => 'AverageBlackLevel',     Format => 'int16u[4]' }, #IB
     0x194 => { #PH
         Name => 'RawMeasuredRGGB',
